Merge branch 'tb/bitmap-walk-with-tree-zero-filter'
[git] / t / test-lib.sh
1 # Test framework for git.  See t/README for usage.
2 #
3 # Copyright (c) 2005 Junio C Hamano
4 #
5 # This program is free software: you can redistribute it and/or modify
6 # it under the terms of the GNU General Public License as published by
7 # the Free Software Foundation, either version 2 of the License, or
8 # (at your option) any later version.
9 #
10 # This program is distributed in the hope that it will be useful,
11 # but WITHOUT ANY WARRANTY; without even the implied warranty of
12 # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
13 # GNU General Public License for more details.
14 #
15 # You should have received a copy of the GNU General Public License
16 # along with this program.  If not, see http://www.gnu.org/licenses/ .
17
18 # Test the binaries we have just built.  The tests are kept in
19 # t/ subdirectory and are run in 'trash directory' subdirectory.
20 if test -z "$TEST_DIRECTORY"
21 then
22         # We allow tests to override this, in case they want to run tests
23         # outside of t/, e.g. for running tests on the test library
24         # itself.
25         TEST_DIRECTORY=$(pwd)
26 else
27         # ensure that TEST_DIRECTORY is an absolute path so that it
28         # is valid even if the current working directory is changed
29         TEST_DIRECTORY=$(cd "$TEST_DIRECTORY" && pwd) || exit 1
30 fi
31 if test -z "$TEST_OUTPUT_DIRECTORY"
32 then
33         # Similarly, override this to store the test-results subdir
34         # elsewhere
35         TEST_OUTPUT_DIRECTORY=$TEST_DIRECTORY
36 fi
37 GIT_BUILD_DIR="$TEST_DIRECTORY"/..
38
39 # If we were built with ASAN, it may complain about leaks
40 # of program-lifetime variables. Disable it by default to lower
41 # the noise level. This needs to happen at the start of the script,
42 # before we even do our "did we build git yet" check (since we don't
43 # want that one to complain to stderr).
44 : ${ASAN_OPTIONS=detect_leaks=0:abort_on_error=1}
45 export ASAN_OPTIONS
46
47 # If LSAN is in effect we _do_ want leak checking, but we still
48 # want to abort so that we notice the problems.
49 : ${LSAN_OPTIONS=abort_on_error=1}
50 export LSAN_OPTIONS
51
52 if test ! -f "$GIT_BUILD_DIR"/GIT-BUILD-OPTIONS
53 then
54         echo >&2 'error: GIT-BUILD-OPTIONS missing (has Git been built?).'
55         exit 1
56 fi
57 . "$GIT_BUILD_DIR"/GIT-BUILD-OPTIONS
58 export PERL_PATH SHELL_PATH
59
60 # Disallow the use of abbreviated options in the test suite by default
61 if test -z "${GIT_TEST_DISALLOW_ABBREVIATED_OPTIONS}"
62 then
63         GIT_TEST_DISALLOW_ABBREVIATED_OPTIONS=true
64         export GIT_TEST_DISALLOW_ABBREVIATED_OPTIONS
65 fi
66
67 ################################################################
68 # It appears that people try to run tests without building...
69 "${GIT_TEST_INSTALLED:-$GIT_BUILD_DIR}/git$X" >/dev/null
70 if test $? != 1
71 then
72         if test -n "$GIT_TEST_INSTALLED"
73         then
74                 echo >&2 "error: there is no working Git at '$GIT_TEST_INSTALLED'"
75         else
76                 echo >&2 'error: you do not seem to have built git yet.'
77         fi
78         exit 1
79 fi
80
81 store_arg_to=
82 opt_required_arg=
83 # $1: option string
84 # $2: name of the var where the arg will be stored
85 mark_option_requires_arg () {
86         if test -n "$opt_required_arg"
87         then
88                 echo "error: options that require args cannot be bundled" \
89                         "together: '$opt_required_arg' and '$1'" >&2
90                 exit 1
91         fi
92         opt_required_arg=$1
93         store_arg_to=$2
94 }
95
96 parse_option () {
97         local opt="$1"
98
99         case "$opt" in
100         -d|--d|--de|--deb|--debu|--debug)
101                 debug=t ;;
102         -i|--i|--im|--imm|--imme|--immed|--immedi|--immedia|--immediat|--immediate)
103                 immediate=t ;;
104         -l|--l|--lo|--lon|--long|--long-|--long-t|--long-te|--long-tes|--long-test|--long-tests)
105                 GIT_TEST_LONG=t; export GIT_TEST_LONG ;;
106         -r)
107                 mark_option_requires_arg "$opt" run_list
108                 ;;
109         --run=*)
110                 run_list=${opt#--*=} ;;
111         -h|--h|--he|--hel|--help)
112                 help=t ;;
113         -v|--v|--ve|--ver|--verb|--verbo|--verbos|--verbose)
114                 verbose=t ;;
115         --verbose-only=*)
116                 verbose_only=${opt#--*=}
117                 ;;
118         -q|--q|--qu|--qui|--quie|--quiet)
119                 # Ignore --quiet under a TAP::Harness. Saying how many tests
120                 # passed without the ok/not ok details is always an error.
121                 test -z "$HARNESS_ACTIVE" && quiet=t ;;
122         --with-dashes)
123                 with_dashes=t ;;
124         --no-bin-wrappers)
125                 no_bin_wrappers=t ;;
126         --no-color)
127                 color= ;;
128         --va|--val|--valg|--valgr|--valgri|--valgrin|--valgrind)
129                 valgrind=memcheck
130                 tee=t
131                 ;;
132         --valgrind=*)
133                 valgrind=${opt#--*=}
134                 tee=t
135                 ;;
136         --valgrind-only=*)
137                 valgrind_only=${opt#--*=}
138                 tee=t
139                 ;;
140         --tee)
141                 tee=t ;;
142         --root=*)
143                 root=${opt#--*=} ;;
144         --chain-lint)
145                 GIT_TEST_CHAIN_LINT=1 ;;
146         --no-chain-lint)
147                 GIT_TEST_CHAIN_LINT=0 ;;
148         -x)
149                 trace=t ;;
150         -V|--verbose-log)
151                 verbose_log=t
152                 tee=t
153                 ;;
154         --write-junit-xml)
155                 write_junit_xml=t
156                 ;;
157         --stress)
158                 stress=t ;;
159         --stress=*)
160                 echo "error: --stress does not accept an argument: '$opt'" >&2
161                 echo "did you mean --stress-jobs=${opt#*=} or --stress-limit=${opt#*=}?" >&2
162                 exit 1
163                 ;;
164         --stress-jobs=*)
165                 stress=t;
166                 stress=${opt#--*=}
167                 case "$stress" in
168                 *[!0-9]*|0*|"")
169                         echo "error: --stress-jobs=<N> requires the number of jobs to run" >&2
170                         exit 1
171                         ;;
172                 *)      # Good.
173                         ;;
174                 esac
175                 ;;
176         --stress-limit=*)
177                 stress=t;
178                 stress_limit=${opt#--*=}
179                 case "$stress_limit" in
180                 *[!0-9]*|0*|"")
181                         echo "error: --stress-limit=<N> requires the number of repetitions" >&2
182                         exit 1
183                         ;;
184                 *)      # Good.
185                         ;;
186                 esac
187                 ;;
188         *)
189                 echo "error: unknown test option '$opt'" >&2; exit 1 ;;
190         esac
191 }
192
193 # Parse options while taking care to leave $@ intact, so we will still
194 # have all the original command line options when executing the test
195 # script again for '--tee' and '--verbose-log' later.
196 for opt
197 do
198         if test -n "$store_arg_to"
199         then
200                 eval $store_arg_to=\$opt
201                 store_arg_to=
202                 opt_required_arg=
203                 continue
204         fi
205
206         case "$opt" in
207         --*|-?)
208                 parse_option "$opt" ;;
209         -?*)
210                 # bundled short options must be fed separately to parse_option
211                 opt=${opt#-}
212                 while test -n "$opt"
213                 do
214                         extra=${opt#?}
215                         this=${opt%$extra}
216                         opt=$extra
217                         parse_option "-$this"
218                 done
219                 ;;
220         *)
221                 echo "error: unknown test option '$opt'" >&2; exit 1 ;;
222         esac
223 done
224 if test -n "$store_arg_to"
225 then
226         echo "error: $opt_required_arg requires an argument" >&2
227         exit 1
228 fi
229
230 if test -n "$valgrind_only"
231 then
232         test -z "$valgrind" && valgrind=memcheck
233         test -z "$verbose" && verbose_only="$valgrind_only"
234 elif test -n "$valgrind"
235 then
236         test -z "$verbose_log" && verbose=t
237 fi
238
239 if test -n "$stress"
240 then
241         verbose=t
242         trace=t
243         immediate=t
244 fi
245
246 TEST_STRESS_JOB_SFX="${GIT_TEST_STRESS_JOB_NR:+.stress-$GIT_TEST_STRESS_JOB_NR}"
247 TEST_NAME="$(basename "$0" .sh)"
248 TEST_NUMBER="${TEST_NAME%%-*}"
249 TEST_NUMBER="${TEST_NUMBER#t}"
250 TEST_RESULTS_DIR="$TEST_OUTPUT_DIRECTORY/test-results"
251 TEST_RESULTS_BASE="$TEST_RESULTS_DIR/$TEST_NAME$TEST_STRESS_JOB_SFX"
252 TRASH_DIRECTORY="trash directory.$TEST_NAME$TEST_STRESS_JOB_SFX"
253 test -n "$root" && TRASH_DIRECTORY="$root/$TRASH_DIRECTORY"
254 case "$TRASH_DIRECTORY" in
255 /*) ;; # absolute path is good
256  *) TRASH_DIRECTORY="$TEST_OUTPUT_DIRECTORY/$TRASH_DIRECTORY" ;;
257 esac
258
259 # If --stress was passed, run this test repeatedly in several parallel loops.
260 if test "$GIT_TEST_STRESS_STARTED" = "done"
261 then
262         : # Don't stress test again.
263 elif test -n "$stress"
264 then
265         if test "$stress" != t
266         then
267                 job_count=$stress
268         elif test -n "$GIT_TEST_STRESS_LOAD"
269         then
270                 job_count="$GIT_TEST_STRESS_LOAD"
271         elif job_count=$(getconf _NPROCESSORS_ONLN 2>/dev/null) &&
272              test -n "$job_count"
273         then
274                 job_count=$((2 * $job_count))
275         else
276                 job_count=8
277         fi
278
279         mkdir -p "$TEST_RESULTS_DIR"
280         stressfail="$TEST_RESULTS_BASE.stress-failed"
281         rm -f "$stressfail"
282
283         stress_exit=0
284         trap '
285                 kill $job_pids 2>/dev/null
286                 wait
287                 stress_exit=1
288         ' TERM INT HUP
289
290         job_pids=
291         job_nr=0
292         while test $job_nr -lt "$job_count"
293         do
294                 (
295                         GIT_TEST_STRESS_STARTED=done
296                         GIT_TEST_STRESS_JOB_NR=$job_nr
297                         export GIT_TEST_STRESS_STARTED GIT_TEST_STRESS_JOB_NR
298
299                         trap '
300                                 kill $test_pid 2>/dev/null
301                                 wait
302                                 exit 1
303                         ' TERM INT
304
305                         cnt=1
306                         while ! test -e "$stressfail" &&
307                               { test -z "$stress_limit" ||
308                                 test $cnt -le $stress_limit ; }
309                         do
310                                 $TEST_SHELL_PATH "$0" "$@" >"$TEST_RESULTS_BASE.stress-$job_nr.out" 2>&1 &
311                                 test_pid=$!
312
313                                 if wait $test_pid
314                                 then
315                                         printf "OK   %2d.%d\n" $GIT_TEST_STRESS_JOB_NR $cnt
316                                 else
317                                         echo $GIT_TEST_STRESS_JOB_NR >>"$stressfail"
318                                         printf "FAIL %2d.%d\n" $GIT_TEST_STRESS_JOB_NR $cnt
319                                 fi
320                                 cnt=$(($cnt + 1))
321                         done
322                 ) &
323                 job_pids="$job_pids $!"
324                 job_nr=$(($job_nr + 1))
325         done
326
327         wait
328
329         if test -f "$stressfail"
330         then
331                 stress_exit=1
332                 echo "Log(s) of failed test run(s):"
333                 for failed_job_nr in $(sort -n "$stressfail")
334                 do
335                         echo "Contents of '$TEST_RESULTS_BASE.stress-$failed_job_nr.out':"
336                         cat "$TEST_RESULTS_BASE.stress-$failed_job_nr.out"
337                 done
338                 rm -rf "$TRASH_DIRECTORY.stress-failed"
339                 # Move the last one.
340                 mv "$TRASH_DIRECTORY.stress-$failed_job_nr" "$TRASH_DIRECTORY.stress-failed"
341         fi
342
343         exit $stress_exit
344 fi
345
346 # if --tee was passed, write the output not only to the terminal, but
347 # additionally to the file test-results/$BASENAME.out, too.
348 if test "$GIT_TEST_TEE_STARTED" = "done"
349 then
350         : # do not redirect again
351 elif test -n "$tee"
352 then
353         mkdir -p "$TEST_RESULTS_DIR"
354
355         # Make this filename available to the sub-process in case it is using
356         # --verbose-log.
357         GIT_TEST_TEE_OUTPUT_FILE=$TEST_RESULTS_BASE.out
358         export GIT_TEST_TEE_OUTPUT_FILE
359
360         # Truncate before calling "tee -a" to get rid of the results
361         # from any previous runs.
362         >"$GIT_TEST_TEE_OUTPUT_FILE"
363
364         (GIT_TEST_TEE_STARTED=done ${TEST_SHELL_PATH} "$0" "$@" 2>&1;
365          echo $? >"$TEST_RESULTS_BASE.exit") | tee -a "$GIT_TEST_TEE_OUTPUT_FILE"
366         test "$(cat "$TEST_RESULTS_BASE.exit")" = 0
367         exit
368 fi
369
370 if test -n "$trace" && test -n "$test_untraceable"
371 then
372         # '-x' tracing requested, but this test script can't be reliably
373         # traced, unless it is run with a Bash version supporting
374         # BASH_XTRACEFD (introduced in Bash v4.1).
375         #
376         # Perform this version check _after_ the test script was
377         # potentially re-executed with $TEST_SHELL_PATH for '--tee' or
378         # '--verbose-log', so the right shell is checked and the
379         # warning is issued only once.
380         if test -n "$BASH_VERSION" && eval '
381              test ${BASH_VERSINFO[0]} -gt 4 || {
382                test ${BASH_VERSINFO[0]} -eq 4 &&
383                test ${BASH_VERSINFO[1]} -ge 1
384              }
385            '
386         then
387                 : Executed by a Bash version supporting BASH_XTRACEFD.  Good.
388         else
389                 echo >&2 "warning: ignoring -x; '$0' is untraceable without BASH_XTRACEFD"
390                 trace=
391         fi
392 fi
393 if test -n "$trace" && test -z "$verbose_log"
394 then
395         verbose=t
396 fi
397
398 # For repeatability, reset the environment to known value.
399 # TERM is sanitized below, after saving color control sequences.
400 LANG=C
401 LC_ALL=C
402 PAGER=cat
403 TZ=UTC
404 export LANG LC_ALL PAGER TZ
405 EDITOR=:
406
407 # GIT_TEST_GETTEXT_POISON should not influence git commands executed
408 # during initialization of test-lib and the test repo. Back it up,
409 # unset and then restore after initialization is finished.
410 if test -n "$GIT_TEST_GETTEXT_POISON"
411 then
412         GIT_TEST_GETTEXT_POISON_ORIG=$GIT_TEST_GETTEXT_POISON
413         unset GIT_TEST_GETTEXT_POISON
414 fi
415
416 # A call to "unset" with no arguments causes at least Solaris 10
417 # /usr/xpg4/bin/sh and /bin/ksh to bail out.  So keep the unsets
418 # deriving from the command substitution clustered with the other
419 # ones.
420 unset VISUAL EMAIL LANGUAGE COLUMNS $("$PERL_PATH" -e '
421         my @env = keys %ENV;
422         my $ok = join("|", qw(
423                 TRACE
424                 DEBUG
425                 TEST
426                 .*_TEST
427                 PROVE
428                 VALGRIND
429                 UNZIP
430                 PERF_
431                 CURL_VERBOSE
432                 TRACE_CURL
433         ));
434         my @vars = grep(/^GIT_/ && !/^GIT_($ok)/o, @env);
435         print join("\n", @vars);
436 ')
437 unset XDG_CACHE_HOME
438 unset XDG_CONFIG_HOME
439 unset GITPERLLIB
440 TEST_AUTHOR_LOCALNAME=author
441 TEST_AUTHOR_DOMAIN=example.com
442 GIT_AUTHOR_EMAIL=${TEST_AUTHOR_LOCALNAME}@${TEST_AUTHOR_DOMAIN}
443 GIT_AUTHOR_NAME='A U Thor'
444 TEST_COMMITTER_LOCALNAME=committer
445 TEST_COMMITTER_DOMAIN=example.com
446 GIT_COMMITTER_EMAIL=${TEST_COMMITTER_LOCALNAME}@${TEST_COMMITTER_DOMAIN}
447 GIT_COMMITTER_NAME='C O Mitter'
448 GIT_MERGE_VERBOSITY=5
449 GIT_MERGE_AUTOEDIT=no
450 export GIT_MERGE_VERBOSITY GIT_MERGE_AUTOEDIT
451 export GIT_AUTHOR_EMAIL GIT_AUTHOR_NAME
452 export GIT_COMMITTER_EMAIL GIT_COMMITTER_NAME
453 export EDITOR
454
455 # Tests using GIT_TRACE typically don't want <timestamp> <file>:<line> output
456 GIT_TRACE_BARE=1
457 export GIT_TRACE_BARE
458
459 check_var_migration () {
460         # the warnings and hints given from this helper depends
461         # on end-user settings, which will disrupt the self-test
462         # done on the test framework itself.
463         case "$GIT_TEST_FRAMEWORK_SELFTEST" in
464         t)      return ;;
465         esac
466
467         old_name=$1 new_name=$2
468         eval "old_isset=\${${old_name}:+isset}"
469         eval "new_isset=\${${new_name}:+isset}"
470
471         case "$old_isset,$new_isset" in
472         isset,)
473                 echo >&2 "warning: $old_name is now $new_name"
474                 echo >&2 "hint: set $new_name too during the transition period"
475                 eval "$new_name=\$$old_name"
476                 ;;
477         isset,isset)
478                 # do this later
479                 # echo >&2 "warning: $old_name is now $new_name"
480                 # echo >&2 "hint: remove $old_name"
481                 ;;
482         esac
483 }
484
485 check_var_migration GIT_FSMONITOR_TEST GIT_TEST_FSMONITOR
486 check_var_migration TEST_GIT_INDEX_VERSION GIT_TEST_INDEX_VERSION
487 check_var_migration GIT_FORCE_PRELOAD_TEST GIT_TEST_PRELOAD_INDEX
488
489 # Use specific version of the index file format
490 if test -n "${GIT_TEST_INDEX_VERSION:+isset}"
491 then
492         GIT_INDEX_VERSION="$GIT_TEST_INDEX_VERSION"
493         export GIT_INDEX_VERSION
494 fi
495
496 # Add libc MALLOC and MALLOC_PERTURB test
497 # only if we are not executing the test with valgrind
498 if test -n "$valgrind" ||
499    test -n "$TEST_NO_MALLOC_CHECK"
500 then
501         setup_malloc_check () {
502                 : nothing
503         }
504         teardown_malloc_check () {
505                 : nothing
506         }
507 else
508         setup_malloc_check () {
509                 MALLOC_CHECK_=3 MALLOC_PERTURB_=165
510                 export MALLOC_CHECK_ MALLOC_PERTURB_
511         }
512         teardown_malloc_check () {
513                 unset MALLOC_CHECK_ MALLOC_PERTURB_
514         }
515 fi
516
517 # Protect ourselves from common misconfiguration to export
518 # CDPATH into the environment
519 unset CDPATH
520
521 unset GREP_OPTIONS
522 unset UNZIP
523
524 case $(echo $GIT_TRACE |tr "[A-Z]" "[a-z]") in
525 1|2|true)
526         GIT_TRACE=4
527         ;;
528 esac
529
530 # Line feed
531 LF='
532 '
533
534 # Single quote
535 SQ=\'
536
537 # UTF-8 ZERO WIDTH NON-JOINER, which HFS+ ignores
538 # when case-folding filenames
539 u200c=$(printf '\342\200\214')
540
541 export _x05 _x35 _x40 _z40 LF u200c EMPTY_TREE EMPTY_BLOB ZERO_OID OID_REGEX
542
543 # Each test should start with something like this, after copyright notices:
544 #
545 # test_description='Description of this test...
546 # This test checks if command xyzzy does the right thing...
547 # '
548 # . ./test-lib.sh
549 test "x$TERM" != "xdumb" && (
550                 test -t 1 &&
551                 tput bold >/dev/null 2>&1 &&
552                 tput setaf 1 >/dev/null 2>&1 &&
553                 tput sgr0 >/dev/null 2>&1
554         ) &&
555         color=t
556
557 if test -n "$color"
558 then
559         # Save the color control sequences now rather than run tput
560         # each time say_color() is called.  This is done for two
561         # reasons:
562         #   * TERM will be changed to dumb
563         #   * HOME will be changed to a temporary directory and tput
564         #     might need to read ~/.terminfo from the original HOME
565         #     directory to get the control sequences
566         # Note:  This approach assumes the control sequences don't end
567         # in a newline for any terminal of interest (command
568         # substitutions strip trailing newlines).  Given that most
569         # (all?) terminals in common use are related to ECMA-48, this
570         # shouldn't be a problem.
571         say_color_error=$(tput bold; tput setaf 1) # bold red
572         say_color_skip=$(tput setaf 4) # blue
573         say_color_warn=$(tput setaf 3) # brown/yellow
574         say_color_pass=$(tput setaf 2) # green
575         say_color_info=$(tput setaf 6) # cyan
576         say_color_reset=$(tput sgr0)
577         say_color_="" # no formatting for normal text
578         say_color () {
579                 test -z "$1" && test -n "$quiet" && return
580                 eval "say_color_color=\$say_color_$1"
581                 shift
582                 printf "%s\\n" "$say_color_color$*$say_color_reset"
583         }
584 else
585         say_color() {
586                 test -z "$1" && test -n "$quiet" && return
587                 shift
588                 printf "%s\n" "$*"
589         }
590 fi
591
592 TERM=dumb
593 export TERM
594
595 error () {
596         say_color error "error: $*"
597         finalize_junit_xml
598         GIT_EXIT_OK=t
599         exit 1
600 }
601
602 BUG () {
603         error >&7 "bug in the test script: $*"
604 }
605
606 say () {
607         say_color info "$*"
608 }
609
610 if test -n "$HARNESS_ACTIVE"
611 then
612         if test "$verbose" = t || test -n "$verbose_only"
613         then
614                 printf 'Bail out! %s\n' \
615                  'verbose mode forbidden under TAP harness; try --verbose-log'
616                 exit 1
617         fi
618 fi
619
620 test "${test_description}" != "" ||
621 error "Test script did not set test_description."
622
623 if test "$help" = "t"
624 then
625         printf '%s\n' "$test_description"
626         exit 0
627 fi
628
629 exec 5>&1
630 exec 6<&0
631 exec 7>&2
632 if test "$verbose_log" = "t"
633 then
634         exec 3>>"$GIT_TEST_TEE_OUTPUT_FILE" 4>&3
635 elif test "$verbose" = "t"
636 then
637         exec 4>&2 3>&1
638 else
639         exec 4>/dev/null 3>/dev/null
640 fi
641
642 # Send any "-x" output directly to stderr to avoid polluting tests
643 # which capture stderr. We can do this unconditionally since it
644 # has no effect if tracing isn't turned on.
645 #
646 # Note that this sets up the trace fd as soon as we assign the variable, so it
647 # must come after the creation of descriptor 4 above. Likewise, we must never
648 # unset this, as it has the side effect of closing descriptor 4, which we
649 # use to show verbose tests to the user.
650 #
651 # Note also that we don't need or want to export it. The tracing is local to
652 # this shell, and we would not want to influence any shells we exec.
653 BASH_XTRACEFD=4
654
655 test_failure=0
656 test_count=0
657 test_fixed=0
658 test_broken=0
659 test_success=0
660
661 test_external_has_tap=0
662
663 die () {
664         code=$?
665         # This is responsible for running the atexit commands even when a
666         # test script run with '--immediate' fails, or when the user hits
667         # ctrl-C, i.e. when 'test_done' is not invoked at all.
668         test_atexit_handler || code=$?
669         if test -n "$GIT_EXIT_OK"
670         then
671                 exit $code
672         else
673                 echo >&5 "FATAL: Unexpected exit with code $code"
674                 exit 1
675         fi
676 }
677
678 file_lineno () {
679         test -z "$GIT_TEST_FRAMEWORK_SELFTEST" && test -n "$BASH" || return 0
680         eval '
681                 local i
682                 for i in ${!BASH_SOURCE[*]}
683                 do
684                         case $i,"${BASH_SOURCE[$i]##*/}" in
685                         0,t[0-9]*.sh) echo "t/${BASH_SOURCE[$i]}:$LINENO: ${1+$1: }"; return;;
686                         *,t[0-9]*.sh) echo "t/${BASH_SOURCE[$i]}:${BASH_LINENO[$(($i-1))]}: ${1+$1: }"; return;;
687                         esac
688                 done
689         '
690 }
691
692 GIT_EXIT_OK=
693 trap 'die' EXIT
694 # Disable '-x' tracing, because with some shells, notably dash, it
695 # prevents running the cleanup commands when a test script run with
696 # '--verbose-log -x' is interrupted.
697 trap '{ code=$?; set +x; } 2>/dev/null; exit $code' INT TERM HUP
698
699 # The user-facing functions are loaded from a separate file so that
700 # test_perf subshells can have them too
701 . "$TEST_DIRECTORY/test-lib-functions.sh"
702
703 # You are not expected to call test_ok_ and test_failure_ directly, use
704 # the test_expect_* functions instead.
705
706 test_ok_ () {
707         if test -n "$write_junit_xml"
708         then
709                 write_junit_xml_testcase "$*"
710         fi
711         test_success=$(($test_success + 1))
712         say_color "" "ok $test_count - $@"
713 }
714
715 test_failure_ () {
716         if test -n "$write_junit_xml"
717         then
718                 junit_insert="<failure message=\"not ok $test_count -"
719                 junit_insert="$junit_insert $(xml_attr_encode "$1")\">"
720                 junit_insert="$junit_insert $(xml_attr_encode \
721                         "$(if test -n "$GIT_TEST_TEE_OUTPUT_FILE"
722                            then
723                                 test-tool path-utils skip-n-bytes \
724                                         "$GIT_TEST_TEE_OUTPUT_FILE" $GIT_TEST_TEE_OFFSET
725                            else
726                                 printf '%s\n' "$@" | sed 1d
727                            fi)")"
728                 junit_insert="$junit_insert</failure>"
729                 if test -n "$GIT_TEST_TEE_OUTPUT_FILE"
730                 then
731                         junit_insert="$junit_insert<system-err>$(xml_attr_encode \
732                                 "$(cat "$GIT_TEST_TEE_OUTPUT_FILE")")</system-err>"
733                 fi
734                 write_junit_xml_testcase "$1" "      $junit_insert"
735         fi
736         test_failure=$(($test_failure + 1))
737         say_color error "$(file_lineno error)not ok $test_count - $1"
738         shift
739         printf '%s\n' "$*" | sed -e 's/^/#      /'
740         test "$immediate" = "" || { finalize_junit_xml; GIT_EXIT_OK=t; exit 1; }
741 }
742
743 test_known_broken_ok_ () {
744         if test -n "$write_junit_xml"
745         then
746                 write_junit_xml_testcase "$* (breakage fixed)"
747         fi
748         test_fixed=$(($test_fixed+1))
749         say_color error "ok $test_count - $@ # TODO known breakage vanished"
750 }
751
752 test_known_broken_failure_ () {
753         if test -n "$write_junit_xml"
754         then
755                 write_junit_xml_testcase "$* (known breakage)"
756         fi
757         test_broken=$(($test_broken+1))
758         say_color warn "not ok $test_count - $@ # TODO known breakage"
759 }
760
761 test_debug () {
762         test "$debug" = "" || eval "$1"
763 }
764
765 match_pattern_list () {
766         arg="$1"
767         shift
768         test -z "$*" && return 1
769         for pattern_
770         do
771                 case "$arg" in
772                 $pattern_)
773                         return 0
774                 esac
775         done
776         return 1
777 }
778
779 match_test_selector_list () {
780         title="$1"
781         shift
782         arg="$1"
783         shift
784         test -z "$1" && return 0
785
786         # Both commas and whitespace are accepted as separators.
787         OLDIFS=$IFS
788         IFS='   ,'
789         set -- $1
790         IFS=$OLDIFS
791
792         # If the first selector is negative we include by default.
793         include=
794         case "$1" in
795                 !*) include=t ;;
796         esac
797
798         for selector
799         do
800                 orig_selector=$selector
801
802                 positive=t
803                 case "$selector" in
804                         !*)
805                                 positive=
806                                 selector=${selector##?}
807                                 ;;
808                 esac
809
810                 test -z "$selector" && continue
811
812                 case "$selector" in
813                         *-*)
814                                 if expr "z${selector%%-*}" : "z[0-9]*[^0-9]" >/dev/null
815                                 then
816                                         echo "error: $title: invalid non-numeric in range" \
817                                                 "start: '$orig_selector'" >&2
818                                         exit 1
819                                 fi
820                                 if expr "z${selector#*-}" : "z[0-9]*[^0-9]" >/dev/null
821                                 then
822                                         echo "error: $title: invalid non-numeric in range" \
823                                                 "end: '$orig_selector'" >&2
824                                         exit 1
825                                 fi
826                                 ;;
827                         *)
828                                 if expr "z$selector" : "z[0-9]*[^0-9]" >/dev/null
829                                 then
830                                         echo "error: $title: invalid non-numeric in test" \
831                                                 "selector: '$orig_selector'" >&2
832                                         exit 1
833                                 fi
834                 esac
835
836                 # Short cut for "obvious" cases
837                 test -z "$include" && test -z "$positive" && continue
838                 test -n "$include" && test -n "$positive" && continue
839
840                 case "$selector" in
841                         -*)
842                                 if test $arg -le ${selector#-}
843                                 then
844                                         include=$positive
845                                 fi
846                                 ;;
847                         *-)
848                                 if test $arg -ge ${selector%-}
849                                 then
850                                         include=$positive
851                                 fi
852                                 ;;
853                         *-*)
854                                 if test ${selector%%-*} -le $arg \
855                                         && test $arg -le ${selector#*-}
856                                 then
857                                         include=$positive
858                                 fi
859                                 ;;
860                         *)
861                                 if test $arg -eq $selector
862                                 then
863                                         include=$positive
864                                 fi
865                                 ;;
866                 esac
867         done
868
869         test -n "$include"
870 }
871
872 maybe_teardown_verbose () {
873         test -z "$verbose_only" && return
874         exec 4>/dev/null 3>/dev/null
875         verbose=
876 }
877
878 last_verbose=t
879 maybe_setup_verbose () {
880         test -z "$verbose_only" && return
881         if match_pattern_list $test_count $verbose_only
882         then
883                 exec 4>&2 3>&1
884                 # Emit a delimiting blank line when going from
885                 # non-verbose to verbose.  Within verbose mode the
886                 # delimiter is printed by test_expect_*.  The choice
887                 # of the initial $last_verbose is such that before
888                 # test 1, we do not print it.
889                 test -z "$last_verbose" && echo >&3 ""
890                 verbose=t
891         else
892                 exec 4>/dev/null 3>/dev/null
893                 verbose=
894         fi
895         last_verbose=$verbose
896 }
897
898 maybe_teardown_valgrind () {
899         test -z "$GIT_VALGRIND" && return
900         GIT_VALGRIND_ENABLED=
901 }
902
903 maybe_setup_valgrind () {
904         test -z "$GIT_VALGRIND" && return
905         if test -z "$valgrind_only"
906         then
907                 GIT_VALGRIND_ENABLED=t
908                 return
909         fi
910         GIT_VALGRIND_ENABLED=
911         if match_pattern_list $test_count $valgrind_only
912         then
913                 GIT_VALGRIND_ENABLED=t
914         fi
915 }
916
917 trace_level_=0
918 want_trace () {
919         test "$trace" = t && {
920                 test "$verbose" = t || test "$verbose_log" = t
921         }
922 }
923
924 # This is a separate function because some tests use
925 # "return" to end a test_expect_success block early
926 # (and we want to make sure we run any cleanup like
927 # "set +x").
928 test_eval_inner_ () {
929         # Do not add anything extra (including LF) after '$*'
930         eval "
931                 want_trace && trace_level_=$(($trace_level_+1)) && set -x
932                 $*"
933 }
934
935 test_eval_ () {
936         # If "-x" tracing is in effect, then we want to avoid polluting stderr
937         # with non-test commands. But once in "set -x" mode, we cannot prevent
938         # the shell from printing the "set +x" to turn it off (nor the saving
939         # of $? before that). But we can make sure that the output goes to
940         # /dev/null.
941         #
942         # There are a few subtleties here:
943         #
944         #   - we have to redirect descriptor 4 in addition to 2, to cover
945         #     BASH_XTRACEFD
946         #
947         #   - the actual eval has to come before the redirection block (since
948         #     it needs to see descriptor 4 to set up its stderr)
949         #
950         #   - likewise, any error message we print must be outside the block to
951         #     access descriptor 4
952         #
953         #   - checking $? has to come immediately after the eval, but it must
954         #     be _inside_ the block to avoid polluting the "set -x" output
955         #
956
957         test_eval_inner_ "$@" </dev/null >&3 2>&4
958         {
959                 test_eval_ret_=$?
960                 if want_trace
961                 then
962                         test 1 = $trace_level_ && set +x
963                         trace_level_=$(($trace_level_-1))
964                 fi
965         } 2>/dev/null 4>&2
966
967         if test "$test_eval_ret_" != 0 && want_trace
968         then
969                 say_color error >&4 "error: last command exited with \$?=$test_eval_ret_"
970         fi
971         return $test_eval_ret_
972 }
973
974 test_run_ () {
975         test_cleanup=:
976         expecting_failure=$2
977
978         if test "${GIT_TEST_CHAIN_LINT:-1}" != 0; then
979                 # turn off tracing for this test-eval, as it simply creates
980                 # confusing noise in the "-x" output
981                 trace_tmp=$trace
982                 trace=
983                 # 117 is magic because it is unlikely to match the exit
984                 # code of other programs
985                 if $(printf '%s\n' "$1" | sed -f "$GIT_BUILD_DIR/t/chainlint.sed" | grep -q '?![A-Z][A-Z]*?!') ||
986                         test "OK-117" != "$(test_eval_ "(exit 117) && $1${LF}${LF}echo OK-\$?" 3>&1)"
987                 then
988                         BUG "broken &&-chain or run-away HERE-DOC: $1"
989                 fi
990                 trace=$trace_tmp
991         fi
992
993         setup_malloc_check
994         test_eval_ "$1"
995         eval_ret=$?
996         teardown_malloc_check
997
998         if test -z "$immediate" || test $eval_ret = 0 ||
999            test -n "$expecting_failure" && test "$test_cleanup" != ":"
1000         then
1001                 setup_malloc_check
1002                 test_eval_ "$test_cleanup"
1003                 teardown_malloc_check
1004         fi
1005         if test "$verbose" = "t" && test -n "$HARNESS_ACTIVE"
1006         then
1007                 echo ""
1008         fi
1009         return "$eval_ret"
1010 }
1011
1012 test_start_ () {
1013         test_count=$(($test_count+1))
1014         maybe_setup_verbose
1015         maybe_setup_valgrind
1016         if test -n "$write_junit_xml"
1017         then
1018                 junit_start=$(test-tool date getnanos)
1019         fi
1020 }
1021
1022 test_finish_ () {
1023         echo >&3 ""
1024         maybe_teardown_valgrind
1025         maybe_teardown_verbose
1026         if test -n "$GIT_TEST_TEE_OFFSET"
1027         then
1028                 GIT_TEST_TEE_OFFSET=$(test-tool path-utils file-size \
1029                         "$GIT_TEST_TEE_OUTPUT_FILE")
1030         fi
1031 }
1032
1033 test_skip () {
1034         to_skip=
1035         skipped_reason=
1036         if match_pattern_list $this_test.$test_count $GIT_SKIP_TESTS
1037         then
1038                 to_skip=t
1039                 skipped_reason="GIT_SKIP_TESTS"
1040         fi
1041         if test -z "$to_skip" && test -n "$run_list" &&
1042            ! match_test_selector_list '--run' $test_count "$run_list"
1043         then
1044                 to_skip=t
1045                 skipped_reason="--run"
1046         fi
1047         if test -z "$to_skip" && test -n "$test_prereq" &&
1048            ! test_have_prereq "$test_prereq"
1049         then
1050                 to_skip=t
1051
1052                 of_prereq=
1053                 if test "$missing_prereq" != "$test_prereq"
1054                 then
1055                         of_prereq=" of $test_prereq"
1056                 fi
1057                 skipped_reason="missing $missing_prereq${of_prereq}"
1058         fi
1059
1060         case "$to_skip" in
1061         t)
1062                 if test -n "$write_junit_xml"
1063                 then
1064                         message="$(xml_attr_encode "$skipped_reason")"
1065                         write_junit_xml_testcase "$1" \
1066                                 "      <skipped message=\"$message\" />"
1067                 fi
1068
1069                 say_color skip >&3 "skipping test: $@"
1070                 say_color skip "ok $test_count # skip $1 ($skipped_reason)"
1071                 : true
1072                 ;;
1073         *)
1074                 false
1075                 ;;
1076         esac
1077 }
1078
1079 # stub; perf-lib overrides it
1080 test_at_end_hook_ () {
1081         :
1082 }
1083
1084 write_junit_xml () {
1085         case "$1" in
1086         --truncate)
1087                 >"$junit_xml_path"
1088                 junit_have_testcase=
1089                 shift
1090                 ;;
1091         esac
1092         printf '%s\n' "$@" >>"$junit_xml_path"
1093 }
1094
1095 xml_attr_encode () {
1096         printf '%s\n' "$@" | test-tool xml-encode
1097 }
1098
1099 write_junit_xml_testcase () {
1100         junit_attrs="name=\"$(xml_attr_encode "$this_test.$test_count $1")\""
1101         shift
1102         junit_attrs="$junit_attrs classname=\"$this_test\""
1103         junit_attrs="$junit_attrs time=\"$(test-tool \
1104                 date getnanos $junit_start)\""
1105         write_junit_xml "$(printf '%s\n' \
1106                 "    <testcase $junit_attrs>" "$@" "    </testcase>")"
1107         junit_have_testcase=t
1108 }
1109
1110 finalize_junit_xml () {
1111         if test -n "$write_junit_xml" && test -n "$junit_xml_path"
1112         then
1113                 test -n "$junit_have_testcase" || {
1114                         junit_start=$(test-tool date getnanos)
1115                         write_junit_xml_testcase "all tests skipped"
1116                 }
1117
1118                 # adjust the overall time
1119                 junit_time=$(test-tool date getnanos $junit_suite_start)
1120                 sed -e "s/\(<testsuite.*\) time=\"[^\"]*\"/\1/" \
1121                         -e "s/<testsuite [^>]*/& time=\"$junit_time\"/" \
1122                         -e '/^ *<\/testsuite/d' \
1123                         <"$junit_xml_path" >"$junit_xml_path.new"
1124                 mv "$junit_xml_path.new" "$junit_xml_path"
1125
1126                 write_junit_xml "  </testsuite>" "</testsuites>"
1127                 write_junit_xml=
1128         fi
1129 }
1130
1131 test_atexit_cleanup=:
1132 test_atexit_handler () {
1133         # In a succeeding test script 'test_atexit_handler' is invoked
1134         # twice: first from 'test_done', then from 'die' in the trap on
1135         # EXIT.
1136         # This condition and resetting 'test_atexit_cleanup' below makes
1137         # sure that the registered cleanup commands are run only once.
1138         test : != "$test_atexit_cleanup" || return 0
1139
1140         setup_malloc_check
1141         test_eval_ "$test_atexit_cleanup"
1142         test_atexit_cleanup=:
1143         teardown_malloc_check
1144 }
1145
1146 test_done () {
1147         GIT_EXIT_OK=t
1148
1149         # Run the atexit commands _before_ the trash directory is
1150         # removed, so the commands can access pidfiles and socket files.
1151         test_atexit_handler
1152
1153         finalize_junit_xml
1154
1155         if test -z "$HARNESS_ACTIVE"
1156         then
1157                 mkdir -p "$TEST_RESULTS_DIR"
1158
1159                 cat >"$TEST_RESULTS_BASE.counts" <<-EOF
1160                 total $test_count
1161                 success $test_success
1162                 fixed $test_fixed
1163                 broken $test_broken
1164                 failed $test_failure
1165
1166                 EOF
1167         fi
1168
1169         if test "$test_fixed" != 0
1170         then
1171                 say_color error "# $test_fixed known breakage(s) vanished; please update test(s)"
1172         fi
1173         if test "$test_broken" != 0
1174         then
1175                 say_color warn "# still have $test_broken known breakage(s)"
1176         fi
1177         if test "$test_broken" != 0 || test "$test_fixed" != 0
1178         then
1179                 test_remaining=$(( $test_count - $test_broken - $test_fixed ))
1180                 msg="remaining $test_remaining test(s)"
1181         else
1182                 test_remaining=$test_count
1183                 msg="$test_count test(s)"
1184         fi
1185         case "$test_failure" in
1186         0)
1187                 if test $test_external_has_tap -eq 0
1188                 then
1189                         if test $test_remaining -gt 0
1190                         then
1191                                 say_color pass "# passed all $msg"
1192                         fi
1193
1194                         # Maybe print SKIP message
1195                         test -z "$skip_all" || skip_all="# SKIP $skip_all"
1196                         case "$test_count" in
1197                         0)
1198                                 say "1..$test_count${skip_all:+ $skip_all}"
1199                                 ;;
1200                         *)
1201                                 test -z "$skip_all" ||
1202                                 say_color warn "$skip_all"
1203                                 say "1..$test_count"
1204                                 ;;
1205                         esac
1206                 fi
1207
1208                 if test -z "$debug"
1209                 then
1210                         test -d "$TRASH_DIRECTORY" ||
1211                         error "Tests passed but trash directory already removed before test cleanup; aborting"
1212
1213                         cd "$TRASH_DIRECTORY/.." &&
1214                         rm -fr "$TRASH_DIRECTORY" || {
1215                                 # try again in a bit
1216                                 sleep 5;
1217                                 rm -fr "$TRASH_DIRECTORY"
1218                         } ||
1219                         error "Tests passed but test cleanup failed; aborting"
1220                 fi
1221                 test_at_end_hook_
1222
1223                 exit 0 ;;
1224
1225         *)
1226                 if test $test_external_has_tap -eq 0
1227                 then
1228                         say_color error "# failed $test_failure among $msg"
1229                         say "1..$test_count"
1230                 fi
1231
1232                 exit 1 ;;
1233
1234         esac
1235 }
1236
1237 if test -n "$valgrind"
1238 then
1239         make_symlink () {
1240                 test -h "$2" &&
1241                 test "$1" = "$(readlink "$2")" || {
1242                         # be super paranoid
1243                         if mkdir "$2".lock
1244                         then
1245                                 rm -f "$2" &&
1246                                 ln -s "$1" "$2" &&
1247                                 rm -r "$2".lock
1248                         else
1249                                 while test -d "$2".lock
1250                                 do
1251                                         say "Waiting for lock on $2."
1252                                         sleep 1
1253                                 done
1254                         fi
1255                 }
1256         }
1257
1258         make_valgrind_symlink () {
1259                 # handle only executables, unless they are shell libraries that
1260                 # need to be in the exec-path.
1261                 test -x "$1" ||
1262                 test "# " = "$(test_copy_bytes 2 <"$1")" ||
1263                 return;
1264
1265                 base=$(basename "$1")
1266                 case "$base" in
1267                 test-*)
1268                         symlink_target="$GIT_BUILD_DIR/t/helper/$base"
1269                         ;;
1270                 *)
1271                         symlink_target="$GIT_BUILD_DIR/$base"
1272                         ;;
1273                 esac
1274                 # do not override scripts
1275                 if test -x "$symlink_target" &&
1276                     test ! -d "$symlink_target" &&
1277                     test "#!" != "$(test_copy_bytes 2 <"$symlink_target")"
1278                 then
1279                         symlink_target=../valgrind.sh
1280                 fi
1281                 case "$base" in
1282                 *.sh|*.perl)
1283                         symlink_target=../unprocessed-script
1284                 esac
1285                 # create the link, or replace it if it is out of date
1286                 make_symlink "$symlink_target" "$GIT_VALGRIND/bin/$base" || exit
1287         }
1288
1289         # override all git executables in TEST_DIRECTORY/..
1290         GIT_VALGRIND=$TEST_DIRECTORY/valgrind
1291         mkdir -p "$GIT_VALGRIND"/bin
1292         for file in $GIT_BUILD_DIR/git* $GIT_BUILD_DIR/t/helper/test-*
1293         do
1294                 make_valgrind_symlink $file
1295         done
1296         # special-case the mergetools loadables
1297         make_symlink "$GIT_BUILD_DIR"/mergetools "$GIT_VALGRIND/bin/mergetools"
1298         OLDIFS=$IFS
1299         IFS=:
1300         for path in $PATH
1301         do
1302                 ls "$path"/git-* 2> /dev/null |
1303                 while read file
1304                 do
1305                         make_valgrind_symlink "$file"
1306                 done
1307         done
1308         IFS=$OLDIFS
1309         PATH=$GIT_VALGRIND/bin:$PATH
1310         GIT_EXEC_PATH=$GIT_VALGRIND/bin
1311         export GIT_VALGRIND
1312         GIT_VALGRIND_MODE="$valgrind"
1313         export GIT_VALGRIND_MODE
1314         GIT_VALGRIND_ENABLED=t
1315         test -n "$valgrind_only" && GIT_VALGRIND_ENABLED=
1316         export GIT_VALGRIND_ENABLED
1317 elif test -n "$GIT_TEST_INSTALLED"
1318 then
1319         GIT_EXEC_PATH=$($GIT_TEST_INSTALLED/git --exec-path)  ||
1320         error "Cannot run git from $GIT_TEST_INSTALLED."
1321         PATH=$GIT_TEST_INSTALLED:$GIT_BUILD_DIR/t/helper:$PATH
1322         GIT_EXEC_PATH=${GIT_TEST_EXEC_PATH:-$GIT_EXEC_PATH}
1323 else # normal case, use ../bin-wrappers only unless $with_dashes:
1324         if test -n "$no_bin_wrappers"
1325         then
1326                 with_dashes=t
1327         else
1328                 git_bin_dir="$GIT_BUILD_DIR/bin-wrappers"
1329                 if ! test -x "$git_bin_dir/git"
1330                 then
1331                         if test -z "$with_dashes"
1332                         then
1333                                 say "$git_bin_dir/git is not executable; using GIT_EXEC_PATH"
1334                         fi
1335                         with_dashes=t
1336                 fi
1337                 PATH="$git_bin_dir:$PATH"
1338         fi
1339         GIT_EXEC_PATH=$GIT_BUILD_DIR
1340         if test -n "$with_dashes"
1341         then
1342                 PATH="$GIT_BUILD_DIR:$GIT_BUILD_DIR/t/helper:$PATH"
1343         fi
1344 fi
1345 GIT_TEMPLATE_DIR="$GIT_BUILD_DIR"/templates/blt
1346 GIT_CONFIG_NOSYSTEM=1
1347 GIT_ATTR_NOSYSTEM=1
1348 export PATH GIT_EXEC_PATH GIT_TEMPLATE_DIR GIT_CONFIG_NOSYSTEM GIT_ATTR_NOSYSTEM
1349
1350 if test -z "$GIT_TEST_CMP"
1351 then
1352         if test -n "$GIT_TEST_CMP_USE_COPIED_CONTEXT"
1353         then
1354                 GIT_TEST_CMP="$DIFF -c"
1355         else
1356                 GIT_TEST_CMP="$DIFF -u"
1357         fi
1358 fi
1359
1360 GITPERLLIB="$GIT_BUILD_DIR"/perl/build/lib
1361 export GITPERLLIB
1362 test -d "$GIT_BUILD_DIR"/templates/blt || {
1363         error "You haven't built things yet, have you?"
1364 }
1365
1366 if ! test -x "$GIT_BUILD_DIR"/t/helper/test-tool$X
1367 then
1368         echo >&2 'You need to build test-tool:'
1369         echo >&2 'Run "make t/helper/test-tool" in the source (toplevel) directory'
1370         exit 1
1371 fi
1372
1373 # Test repository
1374 rm -fr "$TRASH_DIRECTORY" || {
1375         GIT_EXIT_OK=t
1376         echo >&5 "FATAL: Cannot prepare test area"
1377         exit 1
1378 }
1379
1380 HOME="$TRASH_DIRECTORY"
1381 GNUPGHOME="$HOME/gnupg-home-not-used"
1382 export HOME GNUPGHOME
1383
1384 if test -z "$TEST_NO_CREATE_REPO"
1385 then
1386         test_create_repo "$TRASH_DIRECTORY"
1387 else
1388         mkdir -p "$TRASH_DIRECTORY"
1389 fi
1390
1391 # Use -P to resolve symlinks in our working directory so that the cwd
1392 # in subprocesses like git equals our $PWD (for pathname comparisons).
1393 cd -P "$TRASH_DIRECTORY" || exit 1
1394
1395 this_test=${0##*/}
1396 this_test=${this_test%%-*}
1397 if match_pattern_list "$this_test" $GIT_SKIP_TESTS
1398 then
1399         say_color info >&3 "skipping test $this_test altogether"
1400         skip_all="skip all tests in $this_test"
1401         test_done
1402 fi
1403
1404 if test -n "$write_junit_xml"
1405 then
1406         junit_xml_dir="$TEST_OUTPUT_DIRECTORY/out"
1407         mkdir -p "$junit_xml_dir"
1408         junit_xml_base=${0##*/}
1409         junit_xml_path="$junit_xml_dir/TEST-${junit_xml_base%.sh}.xml"
1410         junit_attrs="name=\"${junit_xml_base%.sh}\""
1411         junit_attrs="$junit_attrs timestamp=\"$(TZ=UTC \
1412                 date +%Y-%m-%dT%H:%M:%S)\""
1413         write_junit_xml --truncate "<testsuites>" "  <testsuite $junit_attrs>"
1414         junit_suite_start=$(test-tool date getnanos)
1415         if test -n "$GIT_TEST_TEE_OUTPUT_FILE"
1416         then
1417                 GIT_TEST_TEE_OFFSET=0
1418         fi
1419 fi
1420
1421 # Convenience
1422 # A regexp to match 5, 35 and 40 hexdigits
1423 _x05='[0-9a-f][0-9a-f][0-9a-f][0-9a-f][0-9a-f]'
1424 _x35="$_x05$_x05$_x05$_x05$_x05$_x05$_x05"
1425 _x40="$_x35$_x05"
1426
1427 test_oid_init
1428
1429 ZERO_OID=$(test_oid zero)
1430 OID_REGEX=$(echo $ZERO_OID | sed -e 's/0/[0-9a-f]/g')
1431 EMPTY_TREE=$(test_oid empty_tree)
1432 EMPTY_BLOB=$(test_oid empty_blob)
1433 _z40=$ZERO_OID
1434
1435 # Provide an implementation of the 'yes' utility; the upper bound
1436 # limit is there to help Windows that cannot stop this loop from
1437 # wasting cycles when the downstream stops reading, so do not be
1438 # tempted to turn it into an infinite loop. cf. 6129c930 ("test-lib:
1439 # limit the output of the yes utility", 2016-02-02)
1440 yes () {
1441         if test $# = 0
1442         then
1443                 y=y
1444         else
1445                 y="$*"
1446         fi
1447
1448         i=0
1449         while test $i -lt 99
1450         do
1451                 echo "$y"
1452                 i=$(($i+1))
1453         done
1454 }
1455
1456 # The GIT_TEST_FAIL_PREREQS code hooks into test_set_prereq(), and
1457 # thus needs to be set up really early, and set an internal variable
1458 # for convenience so the hot test_set_prereq() codepath doesn't need
1459 # to call "git env--helper" (via test_bool_env). Only do that work
1460 # if needed by seeing if GIT_TEST_FAIL_PREREQS is set at all.
1461 GIT_TEST_FAIL_PREREQS_INTERNAL=
1462 if test -n "$GIT_TEST_FAIL_PREREQS"
1463 then
1464         if test_bool_env GIT_TEST_FAIL_PREREQS false
1465         then
1466                 GIT_TEST_FAIL_PREREQS_INTERNAL=true
1467                 test_set_prereq FAIL_PREREQS
1468         fi
1469 else
1470         test_lazy_prereq FAIL_PREREQS '
1471                 test_bool_env GIT_TEST_FAIL_PREREQS false
1472         '
1473 fi
1474
1475 # Fix some commands on Windows, and other OS-specific things
1476 uname_s=$(uname -s)
1477 case $uname_s in
1478 *MINGW*)
1479         # Windows has its own (incompatible) sort and find
1480         sort () {
1481                 /usr/bin/sort "$@"
1482         }
1483         find () {
1484                 /usr/bin/find "$@"
1485         }
1486         # git sees Windows-style pwd
1487         pwd () {
1488                 builtin pwd -W
1489         }
1490         # no POSIX permissions
1491         # backslashes in pathspec are converted to '/'
1492         # exec does not inherit the PID
1493         test_set_prereq MINGW
1494         test_set_prereq NATIVE_CRLF
1495         test_set_prereq SED_STRIPS_CR
1496         test_set_prereq GREP_STRIPS_CR
1497         GIT_TEST_CMP=mingw_test_cmp
1498         ;;
1499 *CYGWIN*)
1500         test_set_prereq POSIXPERM
1501         test_set_prereq EXECKEEPSPID
1502         test_set_prereq CYGWIN
1503         test_set_prereq SED_STRIPS_CR
1504         test_set_prereq GREP_STRIPS_CR
1505         ;;
1506 FreeBSD)
1507         test_set_prereq REGEX_ILLSEQ
1508         test_set_prereq POSIXPERM
1509         test_set_prereq BSLASHPSPEC
1510         test_set_prereq EXECKEEPSPID
1511         ;;
1512 *)
1513         test_set_prereq POSIXPERM
1514         test_set_prereq BSLASHPSPEC
1515         test_set_prereq EXECKEEPSPID
1516         ;;
1517 esac
1518
1519 ( COLUMNS=1 && test $COLUMNS = 1 ) && test_set_prereq COLUMNS_CAN_BE_1
1520 test -z "$NO_PERL" && test_set_prereq PERL
1521 test -z "$NO_PTHREADS" && test_set_prereq PTHREADS
1522 test -z "$NO_PYTHON" && test_set_prereq PYTHON
1523 test -n "$USE_LIBPCRE1$USE_LIBPCRE2" && test_set_prereq PCRE
1524 test -n "$USE_LIBPCRE1" && test_set_prereq LIBPCRE1
1525 test -n "$USE_LIBPCRE2" && test_set_prereq LIBPCRE2
1526 test -z "$NO_GETTEXT" && test_set_prereq GETTEXT
1527
1528 if test -n "$GIT_TEST_GETTEXT_POISON_ORIG"
1529 then
1530         GIT_TEST_GETTEXT_POISON=$GIT_TEST_GETTEXT_POISON_ORIG
1531         export GIT_TEST_GETTEXT_POISON
1532         unset GIT_TEST_GETTEXT_POISON_ORIG
1533 fi
1534
1535 test_lazy_prereq C_LOCALE_OUTPUT '
1536         ! test_bool_env GIT_TEST_GETTEXT_POISON false
1537 '
1538
1539 if test -z "$GIT_TEST_CHECK_CACHE_TREE"
1540 then
1541         GIT_TEST_CHECK_CACHE_TREE=true
1542         export GIT_TEST_CHECK_CACHE_TREE
1543 fi
1544
1545 test_lazy_prereq PIPE '
1546         # test whether the filesystem supports FIFOs
1547         test_have_prereq !MINGW,!CYGWIN &&
1548         rm -f testfifo && mkfifo testfifo
1549 '
1550
1551 test_lazy_prereq SYMLINKS '
1552         # test whether the filesystem supports symbolic links
1553         ln -s x y && test -h y
1554 '
1555
1556 test_lazy_prereq FILEMODE '
1557         test "$(git config --bool core.filemode)" = true
1558 '
1559
1560 test_lazy_prereq CASE_INSENSITIVE_FS '
1561         echo good >CamelCase &&
1562         echo bad >camelcase &&
1563         test "$(cat CamelCase)" != good
1564 '
1565
1566 test_lazy_prereq FUNNYNAMES '
1567         test_have_prereq !MINGW &&
1568         touch -- \
1569                 "FUNNYNAMES tab embedded" \
1570                 "FUNNYNAMES \"quote embedded\"" \
1571                 "FUNNYNAMES newline
1572 embedded" 2>/dev/null &&
1573         rm -- \
1574                 "FUNNYNAMES tab embedded" \
1575                 "FUNNYNAMES \"quote embedded\"" \
1576                 "FUNNYNAMES newline
1577 embedded" 2>/dev/null
1578 '
1579
1580 test_lazy_prereq UTF8_NFD_TO_NFC '
1581         # check whether FS converts nfd unicode to nfc
1582         auml=$(printf "\303\244")
1583         aumlcdiar=$(printf "\141\314\210")
1584         >"$auml" &&
1585         test -f "$aumlcdiar"
1586 '
1587
1588 test_lazy_prereq AUTOIDENT '
1589         sane_unset GIT_AUTHOR_NAME &&
1590         sane_unset GIT_AUTHOR_EMAIL &&
1591         git var GIT_AUTHOR_IDENT
1592 '
1593
1594 test_lazy_prereq EXPENSIVE '
1595         test -n "$GIT_TEST_LONG"
1596 '
1597
1598 test_lazy_prereq EXPENSIVE_ON_WINDOWS '
1599         test_have_prereq EXPENSIVE || test_have_prereq !MINGW,!CYGWIN
1600 '
1601
1602 test_lazy_prereq USR_BIN_TIME '
1603         test -x /usr/bin/time
1604 '
1605
1606 test_lazy_prereq NOT_ROOT '
1607         uid=$(id -u) &&
1608         test "$uid" != 0
1609 '
1610
1611 test_lazy_prereq JGIT '
1612         jgit --version
1613 '
1614
1615 # SANITY is about "can you correctly predict what the filesystem would
1616 # do by only looking at the permission bits of the files and
1617 # directories?"  A typical example of !SANITY is running the test
1618 # suite as root, where a test may expect "chmod -r file && cat file"
1619 # to fail because file is supposed to be unreadable after a successful
1620 # chmod.  In an environment (i.e. combination of what filesystem is
1621 # being used and who is running the tests) that lacks SANITY, you may
1622 # be able to delete or create a file when the containing directory
1623 # doesn't have write permissions, or access a file even if the
1624 # containing directory doesn't have read or execute permissions.
1625
1626 test_lazy_prereq SANITY '
1627         mkdir SANETESTD.1 SANETESTD.2 &&
1628
1629         chmod +w SANETESTD.1 SANETESTD.2 &&
1630         >SANETESTD.1/x 2>SANETESTD.2/x &&
1631         chmod -w SANETESTD.1 &&
1632         chmod -r SANETESTD.1/x &&
1633         chmod -rx SANETESTD.2 ||
1634         BUG "cannot prepare SANETESTD"
1635
1636         ! test -r SANETESTD.1/x &&
1637         ! rm SANETESTD.1/x && ! test -f SANETESTD.2/x
1638         status=$?
1639
1640         chmod +rwx SANETESTD.1 SANETESTD.2 &&
1641         rm -rf SANETESTD.1 SANETESTD.2 ||
1642         BUG "cannot clean SANETESTD"
1643         return $status
1644 '
1645
1646 test FreeBSD != $uname_s || GIT_UNZIP=${GIT_UNZIP:-/usr/local/bin/unzip}
1647 GIT_UNZIP=${GIT_UNZIP:-unzip}
1648 test_lazy_prereq UNZIP '
1649         "$GIT_UNZIP" -v
1650         test $? -ne 127
1651 '
1652
1653 run_with_limited_cmdline () {
1654         (ulimit -s 128 && "$@")
1655 }
1656
1657 test_lazy_prereq CMDLINE_LIMIT '
1658         test_have_prereq !MINGW,!CYGWIN &&
1659         run_with_limited_cmdline true
1660 '
1661
1662 run_with_limited_stack () {
1663         (ulimit -s 128 && "$@")
1664 }
1665
1666 test_lazy_prereq ULIMIT_STACK_SIZE '
1667         test_have_prereq !MINGW,!CYGWIN &&
1668         run_with_limited_stack true
1669 '
1670
1671 run_with_limited_open_files () {
1672         (ulimit -n 32 && "$@")
1673 }
1674
1675 test_lazy_prereq ULIMIT_FILE_DESCRIPTORS '
1676         test_have_prereq !MINGW,!CYGWIN &&
1677         run_with_limited_open_files true
1678 '
1679
1680 build_option () {
1681         git version --build-options |
1682         sed -ne "s/^$1: //p"
1683 }
1684
1685 test_lazy_prereq LONG_IS_64BIT '
1686         test 8 -le "$(build_option sizeof-long)"
1687 '
1688
1689 test_lazy_prereq TIME_IS_64BIT 'test-tool date is64bit'
1690 test_lazy_prereq TIME_T_IS_64BIT 'test-tool date time_t-is64bit'
1691
1692 test_lazy_prereq CURL '
1693         curl --version
1694 '
1695
1696 # SHA1 is a test if the hash algorithm in use is SHA-1.  This is both for tests
1697 # which will not work with other hash algorithms and tests that work but don't
1698 # test anything meaningful (e.g. special values which cause short collisions).
1699 test_lazy_prereq SHA1 '
1700         test $(git hash-object /dev/null) = e69de29bb2d1d6434b8b29ae775ad8c2e48c5391
1701 '
1702
1703 test_lazy_prereq REBASE_P '
1704         test -z "$GIT_TEST_SKIP_REBASE_P"
1705 '